
package info.chrm.jtalkerserver;

import java.lang.reflect.Method;

/** Interface for all JTalker PlugIns */
public interface JTalkerPlugInInterface {
 
   /** Gets the name of this PlugIn */
   public String getName();  

   /** Gets the release number string for this PlugIn */
   public String getRelease();  

   /** Gets a full Description for the PlugIn */
   public String getDescription();

   /** Gets available methods in this PlugIn */
   public Method[] getMethods();

   /** Sets user data for calling a method in this user context 
    *  @param _name Users name 
    *  @param _ip Users IP address */   
   public void setCaller(String _name, String _ip);
}
